#!/usr/bin/awk -f

BEGIN{
  Dmin = 20.		# km
}
{
  a = substr($0,169,14)+0.;		# this is for NEW AstOrb format

  H = substr($0,42,7)+0.;
  D_astorb = substr($0,59,7)+0.;

  if (a <= 2.7) {	# VARIABLE ALBEDO!
    A = 0.15;
  } else {
    A = 0.04;
  }

  if (D_astorb < 1.e-8) {
    D = 10.**(0.5 * (6.259 - log10(A) - 0.4*H))
  } else {
    D = D_astorb;
  }

  if (D >= Dmin) {
    print;
  }
}


function log10(x) {
  return log(x)/log(10);
}


