c mean_sigma_weight.f
c Calculate mean and sigma with weights for an array.
c Miroslav Broz (miroslav.broz@email.cz), Nov 24th 2010

      subroutine mean_sigma_weight(x,w,n,mean,sigma)

      integer n
      real*8 x(n),w(n),mean,sigma

      integer i
      real*8 sum,sumw

      if (n.eq.0) then
        mean = 0.d0
        sigma = 0.d0
        return
      endif

      if (n.eq.1) then
        mean = x(1)
        sigma = 0.d0
        return
      endif

      sum = 0.d0
      sumw = 0.d0
      do i = 1, n
        sum = sum + w(i)*x(i)
        sumw = sumw + w(i)
      enddo
      if (sumw.lt.1.d-8) then
        mean = 0.d0
        sigma = 0.d0
        return
      endif
      mean = sum/sumw

      sum = 0.d0
      do i = 1, n
        sum = sum + w(i)*(x(i)-mean)**2
      enddo
      sigma = sqrt(sum/sumw)

      return
      end


